import os
import pandas as pd
import sqlite3


from tklib.tkobject import tkObject
from tklib.tkfile import tkFile
from tklib.tkutils import pint, pfloat


def excel2df(db_path):
    df = pd.read_excel(db_path)
    return df   

def df2excel(df, out_xlsx, delete_original_file = True, print_level = 0):
    if print_level:
        print()
        print(f"Save to {out_xlsx}")

    if delete_original_file:
        os.remove(out_xlsx)

    df.to_excel(out_xlsx)

    if not os.path.isfile(out_xlsx):
        return False

    return True

def df2sqlite3(df, out_sqlite3, delete_original_file = True, print_level = 0):
    if print_level:
        print(f"Save to {out_sqlite3}")

    if delete_original_file:
        os.remove(out_sqlite3)
    
    conn = sqlite3.connect(out_sqlite3)
    df.to_sql('data', conn, if_exists='replace')
    conn.close()

    if not os.path.isfile(out_sqlite3):
        return False

    return True
