import sys
import time

import tklib.tkimport as imp
mpl = imp.import_lib("matplotlib", stop_by_error = False)
from matplotlib import pyplot as plt
from mpl_toolkits.mplot3d.axes3d import Axes3D
from matplotlib import cm
imp.messages(stop_by_error = True)

tk  = imp.import_lib("tkinter", stop_by_error = False)
tkpli = imp.import_lib("tklib.tkgraphic.tkplot_tkinter", stop_by_error = False)
imp.messages(stop_by_error = False)

from tklib.tkobject import tkObject
from tklib.tkutils import pint, pfloat, index2val
from tklib.tkgraphic.tkplotevent import tkPlotEvent, RangeSelector
from tklib.tkgraphic.tkplot_tkinter import tkPlot_tkinter


def select_plt(plt = None, use_tkinter = False, parent = None, title = "tkPlot_tkinter"):
    tkpyplot = tkPlot_pyplot(plt)
    if not use_tkinter:
        root = None
        tkplt = plt
        return tkplt, root, tkpyplot
    else:
        if parent is None:
            parent = tk.Tk()
        tkplt = tkPlot_tkinter(plt, parent = parent, title = title)
        return tkplt, parent, tkpyplot


class tkPlot_pyplot(tkObject):
    def __init__(self, plt = None, **kwargs):
        self.plt = plt
        self.sliders = []

    def __del__(self):
#        print("{} destroyed".format(self.name))
        pass

    def __str__(self):
        return f"plot object extending matplotlib.pyplot ({self.method})"


    def get_window_from_plt(self):
        return self.plt.get_current_fig_manager().window

    def create_window(self, fig):
        pass

    def pause(self, duration = 0.001, **kwargs):
        super().pause(duration, **kwargs)

    def show(self, **kwargs):
        super().show(**kwargs)

    def sleep(self, duration):
        time.sleep(duration)

    def subplots(self, ny, nx, figsize = None, dpi = 100, tight_layout = True, **kwargs):
        fig, axes = self.plt.subplots(ny, nx, figsize = figsize, dpi = dpi, constrained_layout = tight_layout, **kwargs)
    
    def legend(self, ax, line_inf_list = None, draggable = True, **kwargs):
        if line_inf_list is not None:
            ins = sum(line_inf_list)
            labels = [l.get_label() for l in ins]
            _legend = ax.legend(ins, labels, **kwargs)
        else:
            _legend = ax.legend(**kwargs)

        _legend.set_draggable(draggable)

    def update(self):
        pass

    def legend(self, ax, h_list, l_list = None, is_draggable = True, **kwargs):
        if l_list:
            _legend = ax.legend(sum(h_list), sum(l_list), **kwargs)
        else:
            ins_sum = sum(h_list)
            _legend.ax.legend(ins_sum, [l.get_label() for l in ins_sum], **kwargs)
        _legend.draggable(is_draggable)

    def add_slider(self, box, axcolor = 'lightgoldenrodyellow', label = 'A', min = 0.1, max = 10.0, init = 1.0, cmd = None):
        ax = self.plt.axes(box, facecolor = axcolor)
        slider = Slider(ax, label, min, max, valinit = init)

        def update(val):
            print(f"Variable {label} updated to {slider.val}")

        if cmd is None:
            cmd = update

        slider.on_changed(cmd)
        self.sliders.append(slider)

        return slider
