import os
import sys
import glob
from comtypes import client


infile = '41-01-search_MP.pptx'
out_dir = 'images'
image_format = 'png'


nargv = len(sys.argv)
if nargv >= 2: infile = sys.argv[1]
if nargv >= 3: out_dir = sys.argv[2]
if nargv >= 4: image_format = sys.argv[3]


def export_img(fname, out_dir, image_format):
    application = client.CreateObject("PowerPoint.Application")
    application.Visible = True
    cur_dir = os.getcwd()

    print(f"Open [{fname}]")
    presentation = application.Presentations.Open(os.path.join(cur_dir, fname))

    export_path = os.path.join(cur_dir, out_dir)
    print(f"Export as images [png] to [{export_path}]")
    presentation.Export(export_path, FilterName = image_format)

    presentation.Close()
    application.Quit()

def rename_img(out_dir):
    file_list = glob.glob(os.path.join(out_dir, "スライド*.png"))
    for fname in file_list:
        new_fname = fname.replace('スライド', 'slide').lower()
        os.rename(fname, new_fname)

if __name__ == '__main__':
    export_img(infile, out_dir, image_format)
    rename_img(out_dir)
