set script=S-T-Fit_tkFit.py

set datadir=\git\tkProg.data\electrical\2carriers-S
set infile=%datadir%\Ba2CuInO3S-transport property-2carrier.xlsx

set T_label=T.*\(.*K
set sigma_label=sigma
set S_label=S.*\(.*V.*K

set mode=fit
:set mode=EF
:set mode=T

set method=nelder-mead
set wS=1.0e-6
set nmaxiter=1000
set tol=1.0e-5

set l0e=2.5e-9
set l0h=2.5e-9
set me=0.147
set mh=1.436
set rfac_e=0.0
set rfac_h=0.0

goto PARAM

set Eg=1.9
set ED=1.8
set ND=100.0
set EA=0.6347
set NA=1.0e10

set xmin=*
set xmax=*

python %script% "%infile%" --mode=%mode% --method=%method% --wS=%wS% --nmaxiter=%nmaxiter% --tol=%tol% ^
		--T_label=%T_label% --sigma_label=%sigma_label% --S_label=%S_label% ^
		--Eg=%Eg% --ED=%ED% --ND=%ND% --EA=%EA% --NA=%NA% ^
		--me=%me% --mh=%mh% --rfac_e=%rfac_e% --rfac_h=%rfac_h% --l0e=%l0e% --l0h=%l0h% 
goto END


:PARAM
python %script% "%infile%" --mode=%mode% --method=%method% --wS=%wS% --nmaxiter=%nmaxiter% --tol=%tol% ^
		--T_label=%T_label% --sigma_label=%sigma_label% --S_label=%S_label% ^
		--me=%me% --mh=%mh% --rfac_e=%rfac_e% --rfac_h=%rfac_h% 
goto END


:END
