import tkinter as tk
import tkinter.scrolledtext as scrolledtext
import tkinter.font as tkfont
import tkinter.constants as tkc

root = tk.Tk()

# スクロール可能なテキストウィジェットを作成
text = scrolledtext.ScrolledText(root, wrap=tkc.WORD)
text.pack(fill=tkc.BOTH, expand=True)

# HTMLを設定
html = """<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<title>HTML in Tkinter Text Widget</title>
</head>
<body>
<h1>Heading 1</h1>
<p>This is a paragraph.</p>
<ul>
<li>List item 1</li>
<li>List item 2</li>
<li>List item 3</li>
</ul>
</body>
</html>
"""

# HTMLをテキストウィジェットに挿入
text.insert(tkc.END, html)

# フォントを設定
font = tkfont.Font(family="Arial", size=12)
text.configure(font=font)

root.mainloop()