import os
import numpy as np
import pandas as pd


def read_data(infile):
    df = pd.read_excel(infile)
    labels = df.columns.values.tolist()
    x_list = [df[labels[0]].values.tolist()]

    y_list = []
    for i in range(1, len(labels)):
        y_list.append(df[labels[i]].values.tolist())

    return labels, x_list, y_list

def save_data(path, labels, data_list):
    df = pd.DataFrame(np.array(data_list).T, columns = labels)
    df.to_excel(path, index = False, header = True) 

def get_cmd(xk, fit):
    return f"python cal_profile.py {fit.datafile} {xk[0]} {xk[1]} {xk[2]}"
   
def ycal_list(xd_list, xk, fit = None):
    cmd = get_cmd(xk, fit)
#    print(f"launch [{cmd}]")
    os.system(cmd)
    labels, x_list, y_list = read_data(fit.datafile)
    return [y_list[1]]

def minimize_func(xk, x_list, y_list, w_list, fit):
    if x_list is None:
        x_list = fit.x_list
    if y_list is None:
        y_list = fit.y_list

    nx = len(x_list[0])
    S2 = 0.0
    yc_list = ycal_list(x_list, xk, fit)
    for i in range(nx):
        d  = y_list[0][i] - yc_list[0][i]
        S2 += d * d

    return S2
